/**
 * This class describes a set of integers with a maximum cardinality.
 *
 * Values can be added and removed from the set and membership can be
 * tested. The set is backed by an integer array of fixed size.
 * 
 * TASK: Add formal JML contracts to all methods and appropriate
 * class invariants.
 *
 * @author ITI, KIT 
 */
public class BoundedIntegerSet {

    public final int limit;

    private int arr[];

    private int size = 0;
    

    public BoundedIntegerSet(int limit) {
	this.limit = limit;
	this.arr = new int[limit];
    }


    /** Add a value to the set.
     * Upon successful termination <code>this.cotains(elem)</code> is true.
     *
     * @param elem The value to be added
     * @return true iff the value had to be added to the list.
     */
    public boolean add(int elem) {
        /*...*/ return true;
    }
    
    /** Remove a value from the set.
     * Upon successful termination <code>this.contains(elem)</code> is false.
     * @param elem The value to be deleted.
     */
    public void remove(int elem) {/*...*/}


    /** Is a value contained in the set represented by this object?
     * @param eleme The value to be checked.
     * @return true iff elem is found in the set represented by this object
     */
    public boolean contains(int elem) {
        /*...*/ return true;
    }
    
    // other methods
}
